class ParserRC < Hash
  def initialize()  
    super
    @save = Hash.new()
  end

  def save(opt, v='')
    if  /^-(\S)/ =~ opt
      opt = $1
      @save[opt] = true

      self[opt] = v

      return opt, v
    end
    return false 
  end

  def read(is = $stdin)
    while line = is.gets
      opts = line.chomp.split(/[\s\t]+/)
      # p line
      while opt = opts.shift

	_opt = nil 
	if /^(\-\S)/ =~ opt
	  _opt = $1
	else
	  # p opt
	  raise "invalid option %s" % [opt]
	end

	v = true
	if opts.size != 0 && opts[0] !~ /^\-/
	  # v = '"%s"' % [opts.shift]
	  v = '%s' % [opts.shift]
	end
	_opt, v = save(_opt, v)
	if _opt
	  eval("$OPT_%s = \"%s\"" % [_opt, v])
	end
      end 
    end

  end

  def show(os = $stdout)
    self.each do |opt, v|
      _v = eval("$OPT_%s" % [opt]) 
      os.puts "\$OPT_%s ==> %s" % [opt, _v, v] 
    end
  end

  def write(os = $stdout)
    self.each do |opt, v|
      if @save[opt]
	os.print "-%s %s " % [opt, v.to_s]
      end
    end
    os.puts 
  end
end

if __FILE__ == $0 
  prc = ParserRC.new
  prc.save("O")
  prc.save("e", 'ppp')
  prc.write
  prc.read
  prc.show
end

